require_relative 'feed/cve.rb'
require_relative 'feed/cpe.rb'
module NVD
  module Feed
    @@feeds ||= []
    @@etags ||= {}

    def self.etags
      @@etags
    end

    def self.fetch!(tag,etag=nil)
      etags.delete tag
      fetch(tag, etag)
    end

    def self.fetch(tag,etag=nil)
      feed = @@feeds.detect {|f| f::LOCATIONS.any? {|k,v| k == tag || v == tag}}
      location = feed::LOCATIONS.detect {|k,v| k == tag || v == tag}
      return nil unless location
      tag = location[0]
      etag = (etags[tag] || "") unless etag
      puts "Fetching entries for #{tag} ..."
      {tag => feed.fetch(tag,etag)}
    end

    def self.gunzip(gdata)
      zi = Zlib::Inflate.new(Zlib::MAX_WBITS + 32)
      begin
        return zi.inflate(gdata)
  		rescue Zlib::DataError => e
  		  raise "please provide gzipped data"
  		rescue => e
  		  raise e
	  end

  	end

  	def self.feeds
  	  @@feeds
  	end

  end
end
