module NVD
  module Feed

    module CPE
      LOCATIONS = {} unless defined? LOCATIONS
      LOCATIONS["cpe_dictionary"] = "http://static.nvd.nist.gov/feeds/xml/cpe/dictionary/official-cpe-dictionary_v2.3.xml.gz"

      def self.fetch(tag,etag=nil)
        location = LOCATIONS[tag]
        return nil unless location
        retval = {}
        etag = (NVD::Feed.etags[tag] || "" ) unless etag
        data = HTTParty.get(location, {:headers => {"If-None-Match" => etag}})
        NVD::Feed.etags[tag] = data.response.header["etag"]
        return NVD::Feed.etags[tag] if data.nil?
        if location.match(/gz$/)
          data = NVD::Feed.gunzip(data)
          if location.match(/\.xml/)
            xml = HTTParty::Parser.new(data, :xml).parse
            data = []
            xml["cpe_list"]["cpe_item"].each do |item|
              item.each do |k,v|
                v = v.detect {|i| i["lang"] == "en-US"} if v.is_a?(Array)
                item[k] = v["__content__"] if v && v["__content__"]
              end
              item.delete "cpe23_item"
              data << item
            end
          end
        end
        retval[name] = data
      end

      def self.fetch_all
        retval = {}
        LOCATIONS.each do |name, location|
        end
        retval
      end #end method
    end #end CPE module

    @@feeds ||= []
    @@feeds << CPE

  end
end
